import greenfoot.*;
import java.util.ArrayList;

/**
 * LED-Band
 *
 * @author Johannes Neumeyer
 * @version 1.0
 */
public class LEDBand extends GrafikWelt
{
    /** Feld für die einzelnen LEDs */
    private ArrayList<LED> leds;

    /**
     * Erzeugt das Lichterband
     */
    public LEDBand()
    {
        super();
        DarstellungErzeugen();
    }

    /**
     * Beim Einschalten des LED-Bandes werden alle LEDs des Bandes eingeschaltet.
     */
    public void Einschalten()
    {
        for (LED l : leds)
        {
            l.Einschalten();
        }
    }

    /**
     * Für das Beleuchtungsschema MidnightMood wird jede zweite LED
     * auf die Farbe blau gesetzt.
     */
    public void MidnightMood()
    {
        Einschalten();

        leds.get(1).LichtfarbeSetzen("blau");
        leds.get(3).LichtfarbeSetzen("blau");
        leds.get(5).LichtfarbeSetzen("blau");
        leds.get(7).LichtfarbeSetzen("blau");
        leds.get(9).LichtfarbeSetzen("blau");
    }

    /**
     * Die grafische Darstellung eines LED-Bandes wird erzeugt.
     */
    private void DarstellungErzeugen()
    {
        Rechteck band;
        band = new Rechteck();
        band.GrößeSetzen(740, 19);
        band.PositionSetzen(20, 441);
        band.FarbeSetzen("grau");

        leds = new ArrayList();

        for (int index = 0; index < 11; index = index + 1)
        {
            leds.add(new LED(index * 70 + 40, 450));
        }
    }
}
