import java.util.ArrayList;

/**
 * Beleuchtung einer Bühne mit Scheinwerfern
 *
 * @author Johannes Neumeyer
 * @version 1.0
 */
public class Buehnenbeleuchtung extends GrafikWelt
{
    /** Die Scheinwerfergruppe */
    private ArrayList<Scheinwerfer> scheinwerfer;

    /**
     * Legt die Scheinwerfer an
     */
    public Buehnenbeleuchtung()
    {
        super();
        scheinwerfer = new ArrayList();

        // Scheinwerfer erstellen
        for (int index = 0; index < 5; index = index + 1)
        {
            scheinwerfer.add(new Scheinwerfer());
        }     
    }

    /**
     * Stellt alle Scheinwerfer in einer Reihe auf.
     */
    public void ScheinwerferAufstellen()
    {
        for (int index = 0; index < scheinwerfer.size(); index = index + 1)
        {
            scheinwerfer.get(index).PositionSetzen(index * 65 + 40, 450);
            scheinwerfer.get(index).WinkelSetzen(0);
        }
    }   

    /**
     * Alle Scheinwerfer der Anlage werden eingeschalten.
     */
    public void AnlageEinschalten()
    {
        for (Scheinwerfer s : scheinwerfer)
        {
            s.ScheinwerferEinschalten();
        }
    }
}
