/**
 * Laserscheinwerfer mit buntem Lichtkegel
 *
 * @author Johannes Neumeyer
 * @version 1.0
 */
public class Scheinwerfer extends Figur
{    
    
    /**
     * Standardkonstruktor
     */
    public Scheinwerfer()
    {
        super();
        GrafikWelt.dieWelt.addObject(this, 0, 0);
        FigurFestlegen();       
    }
    /**
     * Konstruktor mit Positionsangabe für den Scheinwerfer
     * @param x x-Position des Scheinwerfers
     * @param y y-Position des Scheinwerfers
     */
    public Scheinwerfer(int xPos, int yPos)
    {
        super();
        GrafikWelt.dieWelt.addObject(this, 0, 0);
        PositionSetzen(xPos, yPos);
        FigurFestlegen();       
    }

    /**
     * Gestaltet die grafische Darstellung des Scheinwerfers.
     */
    private void FigurFestlegen()
    {
        FigurteilFestlegenEllipse(-50, -50, 100, 100, "schwarz");
        FigurteilFestlegenRechteck(-50, -50, 100, 50, "schwarz");
        FigurteilFestlegenRechteck(-50, -50, 2, 125, "schwarz");
        FigurteilFestlegenRechteck(48, -50, 2, 125, "schwarz");
        FigurteilFestlegenRechteck(-50, 75, 100, 2, "schwarz");
    }

    /**
     * Stellt den Scheinwerfer eingeschaltet (also mit Lichtkegel) dar.
     */
    public void ScheinwerferEinschalten()
    {
        EigeneFigurLöschen();
        int x2 = (int) (- Math.sin(Math.toRadians(2.5)) * 4000);
        int y2 = (int) (- Math.cos(Math.toRadians(2.5)) * 4000);
        int x3 = (int) (Math.sin(Math.toRadians(2.5)) * 4000);
        int y3 = (int) (- Math.cos(Math.toRadians(2.5)) * 4000);

        FigurteilFestlegenDreieck(0, 0, x2, y2, x3, y3, "gelb");
        FigurteilFestlegenEllipse(-50, -50, 100, 100, "schwarz");
        FigurteilFestlegenRechteck(-50, -50, 100, 50, "schwarz");
        FigurteilFestlegenRechteck(-50, -50, 2, 125, "schwarz");
        FigurteilFestlegenRechteck(48, -50, 2, 125, "schwarz");
        FigurteilFestlegenRechteck(-50, 75, 100, 2, "schwarz");
    }

    /**
     * Stellt den Scheinwerfer ausgeschaltet dar.
     */
    public void ScheinwerferAusschalten()
    {
        EigeneFigurLöschen();     
        FigurteilFestlegenEllipse(-50, -50, 100, 100, "schwarz");
        FigurteilFestlegenRechteck(-50, -50, 100, 50, "schwarz");
        FigurteilFestlegenRechteck(-50, -50, 2, 125, "schwarz");
        FigurteilFestlegenRechteck(48, -50, 2, 125, "schwarz");
        FigurteilFestlegenRechteck(-50, 75, 100, 2, "schwarz");
    }

    /**
     * Setzt die Lichtfarbe des Scheinwerfers wie angegeben.
     * @param farbe Farbe des Scheinwerfers
     */
    public void LichtfarbeSetzen(String farbe)
    {
        EigeneFigurLöschen();
        int x2 = (int) (- Math.sin(Math.toRadians(2.5)) * 4000);
        int y2 = (int) (- Math.cos(Math.toRadians(2.5)) * 4000);
        int x3 = (int) (Math.sin(Math.toRadians(2.5)) * 4000);
        int y3 = (int) (- Math.cos(Math.toRadians(2.5)) * 4000);

        FigurteilFestlegenDreieck(0, 0, x2, y2, x3, y3, farbe);
        FigurteilFestlegenEllipse(-50, -50, 100, 100, "schwarz");
        FigurteilFestlegenRechteck(-50, -50, 100, 50, "schwarz");
        FigurteilFestlegenRechteck(-50, -50, 2, 125, "schwarz");
        FigurteilFestlegenRechteck(48, -50, 2, 125, "schwarz");
        FigurteilFestlegenRechteck(-50, 75, 100, 2, "schwarz");
    }
}
