import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.util.ArrayList;
/**
 * Jump 'n' Run-Spiel mit dem Protagonisten Dorian
 *
 * @author Johannes Neumeyer
 * @version 1.0
 */
public class DorianLand extends GrafikWelt
{
    private Dorian dorian;

    /**
     * Legt das Default-Szenorian mit Level 1 und die Spielfigur an
     */
    public DorianLand()
    {
        this(2);
    }
    
    /**
     * Legt das Szenorian und die Spielfigur an
     * @param levelNr das gewünschte Spiellevel
     */
    public DorianLand(int levelNr)
    {        
        super();
        dorian = new Dorian();
        addObject(dorian, dorian.XPositionGeben(), dorian.YPositionGeben());
        Text text = new Text();
        addObject(text, 0 , 0);
        text.TextSetzen("← →: Gehen     Leertaste: Springen");
        text.PositionSetzen(300, 500);
        LevelSetzen(levelNr);
    }

    /**
     * Setzt das gewünschte Level.
     * @param levelNr das gewünschte Spiellevel
     */
    public void LevelSetzen(int levelNr)
    {
        switch (levelNr)
        {
            case 1:
            Level1();
            break;            

            case 2:
            Level2();
            break;            

            default:
            System.out.println("Ein Level mit dieser Nummer existiert nicht!");
        }
    }

    /**
     * Erstellt die Welt für Level 1.
     */
    private void Level1()
    {
        // Weg
        Stahltraeger weg;
        weg = new Stahltraeger(800);
        addObject(weg, 0 , 0);
        weg.PositionSetzen(0, 400);

        // Kisten und Untier
        Kiste k1;
        k1 = new Kiste();
        addObject(k1, 0 , 0);
        k1.PositionSetzen(250, 350);
        Kiste k2;
        k2 = new Kiste();
        addObject(k2, 0 , 0);
        k2.PositionSetzen(450, 350);
        Gleiter u1;
        u1 = new Gleiter();
        addObject(u1, 0 , 0);
        u1.PositionSetzen(375, 375);

        // Ziel
        Ziel ziel;
        ziel = new Ziel();
        addObject(ziel, 0 , 0);
        ziel.PositionSetzen(735, 250);

        /*
         * Zu ergänzender Code
         */
        Stahltraeger st;
        st = new Stahltraeger();
        addObject(st, 0 , 0);
        st.PositionSetzen(275, 325);

        Kiste k3;
        k3 = new Kiste();
        addObject(k3, 0 , 0);
        k3.PositionSetzen(635, 350);

        Kiste k4;
        k4 = new Kiste();
        addObject(k4, 0 , 0);
        k4.PositionSetzen(685, 350);

        Kiste k5;
        k5 = new Kiste();
        addObject(k5, 0 , 0);
        k5.PositionSetzen(685, 300);
    }   
    
    /**
     * Erstellt die Welt für Level 2.
     */
    private void Level2()
    {
        // Weg oben
        Stahltraeger oben = new Stahltraeger(100);
        addObject(oben, 0 , 0);
        oben.PositionSetzen(0, 150);
      
        // Weg unten
        Stahltraeger unten = new Stahltraeger(800);
        addObject(unten, 0 , 0);
        unten.PositionSetzen(100, 400);

        // Ziel
        Ziel ziel;
        ziel = new Ziel();
        addObject(ziel, 0 , 0);
        ziel.PositionSetzen(735, 275);

        // Treppe1 bauen
        ArrayList<Stufe> treppe1; 
        treppe1 = new ArrayList();

        // Treppenstufen erzeugen und dem Feld hinzufügen
        treppe1.add(new Stufe(10));
        addObject(treppe1.get(0), 0 , 0);
        treppe1.add(new Stufe(9));
        addObject(treppe1.get(1), 0 , 0);
        treppe1.add(new Stufe(8));
        addObject(treppe1.get(2), 0 , 0);
        treppe1.add(new Stufe(3));
        addObject(treppe1.get(3), 0 , 0);

        // Treppenstufen positionieren
        treppe1.get(0).XPositionSetzen(100);
        treppe1.get(1).XPositionSetzen(125);
        treppe1.get(2).XPositionSetzen(150);
        treppe1.get(3).XPositionSetzen(275);        

        // Treppe2 bauen

    }

    /**
     * Mitverantwortlich für die Steuerung von Dorian
     */
    @Override public void act()
    {
        super.act();
        if (dorian.Berührt("grün"))
        {
            Greenfoot.stop();
            dorian.Stoppen();
        }

        else if (dorian.Berührt("cyan"))
        {
            Greenfoot.stop();
            dorian.Stoppen();
        }
    }
}
