/**
 * Eine Kiste im Dorianland
 *
 * @author Johannes Neumeyer
 * @version 1.0
 */
class Kiste extends DLRechteck
{
    private Rechteck brettLO;
    private Rechteck brettLU;

    // Größe der Kiste in 50er-Schritten (Kann die Werte 1, 2, 3, ... annehmen.)
    private int größe;
    private final int faktor = 50;
    private int breiteBrett;

    /**
     * Standardkonstruktor
     */
    public Kiste()
    {
        super();
        breiteBrett = faktor / 10;
        KisteAnlegen(1);
    }

    /**
     * Konstruktor mit Größenangabe
     * @param größe Größe der Kiste
     */
    public Kiste(int größe)
    {
        super();
        breiteBrett = größe * faktor / 10;
        KisteAnlegen(größe);
    }

    /**
     * Legt die Kiste an.
     * @param größe Größe der Kiste
     */
    private void KisteAnlegen(int größe)
    {
        this.größe = größe;
        GrößeSetzen(größe * faktor, größe * faktor);
        FarbeSetzen("braun");

        brettLO = new Rechteck();
        GrafikWelt.dieWelt.addObject(brettLO, 0 , 0);
        brettLO.FarbeSetzen("schwarz");        
        brettLO.GrößeSetzen(breiteBrett, größe * faktor);
        brettLO.PositionSetzen((int) (x + 0.5 * (größe * faktor) - breiteBrett / 2), y);
        brettLO.WinkelSetzen(45);

        brettLU = new Rechteck();
        GrafikWelt.dieWelt.addObject(brettLU, 0 , 0);
        brettLU.FarbeSetzen("schwarz");
        brettLU.PositionSetzen((int) (x + 0.5 * (größe * faktor) - breiteBrett / 2), y);
        brettLU.GrößeSetzen(breiteBrett, größe * faktor);
        brettLU.WinkelSetzen(135);
    }

    /**
     * Setzt die Position aller Komponenten der Kiste.
     * @param xNeu die (neue) x-Koordinate
     * @param yNeu die (neue) y-Koordinate
     */
    @Override void PositionSetzen(int xNeu, int yNeu)
    {
        super.PositionSetzen(xNeu, yNeu);
        brettLO.PositionSetzen((int) (xNeu + 0.5 * (größe * faktor) - breiteBrett / 2), yNeu);
        brettLU.PositionSetzen((int) (xNeu + 0.5 * (größe * faktor) - breiteBrett / 2), yNeu);
    }

    /**
     * Gibt die Höhe der Kiste zurück.
     * @return Höhe der Kiste
     */
    private int HöheGeben()
    {
        return höhe;
    }
}
