import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Stellt die Fahrbahn auf dem Ausgabefenster dar.
 *
 * @author Albert Wiedemann
 * @version 1.0
 */
class FahrbahnSymbol
{
    /** x-Position der linken, oberen Ecke */
    private int x;
    /** y-Position der linken, oberen Ecke */
    private int y;
    /** Fahrbahnbelag */
    private Rechteck hintergrund;
    /** Haltelinie */
    private Rechteck haltelinie;

    /**
     * Erzeugt das FahrbahnSymbol
     */
    FahrbahnSymbol()
    {
        x = 0;
        y = 0;
        hintergrund = new Rechteck();
        GrafikWelt.dieWelt.addObject(hintergrund, 0, 0);
        hintergrund.PositionSetzen(x, y);
        hintergrund.GrößeSetzen(20, 600);
        hintergrund.FarbeSetzen("grau");
        haltelinie = new Rechteck();
        GrafikWelt.dieWelt.addObject(haltelinie, 0, 0);
        haltelinie.PositionSetzen(x + 3, y + 200);
        haltelinie.GrößeSetzen(17, 3);
        haltelinie.FarbeSetzen("weiß");
    }

    /**
     * Setzt die Position der Fahrbahn.
     * @param x x-Position des Kreuzungsmittelpunkts
     * @param y y-Position des Kreuzungsmittelpunkts
     */
    void PositionSetzen(int x, int y)
    {
        this.x = x;
        this.y = y;
        hintergrund.PositionSetzen(x, y);
        haltelinie.PositionSetzen(x + 3, y + 200);
    }

    /**
     * Meldet die Eintrittsposition des Fahrzeugs
     * @return Startposition des Fahrzeugs
     */
    int EintrittsPositionGeben()
    {
        return y + 600;
    }

    /**
     * Meldet die Austrittsposition des Fahrzeugs
     * @return Austrittsposition des Fahrzeugs
     */
    int AustrittsPositionGeben()
    {
        return y;
    }

    /**
     * Meldet den Abstand zum inneren Fahrbahnrand
     * @return Abstand des Fahrzeugs
     */
    int RandAbstandGeben()
    {
        return 5;
    }

    /**
     * Meldet die Position der Haltelinie
     * @return Haltelinienposition
     */
    int HaltelinienPositionGeben()
    {
        return y + 205;
    }
}
