/**
 * Feld eines Schachbretts
 *
 * @author Johannes Neumeyer
 * @version 1.0
 */
public class SchachKaestchen extends Rechteck
{
    /**
     * Speichert eine Referenz auf die Figur, die sich auf dem Feld befindet
     * bzw. die leere Referenz, wenn keine Figur auf dem Feld steht.
     */
    private Figur eigeneFigur;
    
    /**
     * Legt ein Schachfeld mit den Maßen 50 x 50 fest, das anfangs unbesetzt ist.
     */
    SchachKaestchen()
    {
        super();
        GrafikWelt.dieWelt.addObject(this, 0, 0);
        this.GrößeSetzen(50, 50);
        eigeneFigur = null;
    }
    
    /**
     * Setzt die Referenz der Figur, die das Feld nun besetzt,
     * und platziert die Figur auf dem Feld.
     * @param spielfigur die Figur für dieses Feld
     */
    void BelegenMit(Figur spielfigur)
    {
        eigeneFigur = spielfigur;
        spielfigur.PositionSetzen(this.x + 25, this.y + 25);
    }
}