import java.util.ArrayList;

/**
 * Spielfeld des Spiels XXO (Tic Tac Toe), bestehend aus neun Kästchen
 *
 * @author Johannes Neumeyer
 * @version 1.0
 */
public class XXO extends GrafikWelt
{
    ArrayList<ArrayList<XXOKaestchen>> spielfeld;
    
    public XXO()
    {
        /** Erstellen des zweidimensionalen Felds */
        spielfeld = new ArrayList<ArrayList<XXOKaestchen>>();
        
        /*
         * Befüllen des zweidimensionalen Felds
         */
        for (int zeile = 0; zeile < 3; zeile = zeile + 1)
        {
            // Das "äußere" Feld verwaltet die einzelnen Spielfeldzeilen,
            // jeweils bestehend aus einem "inneren" Feld
            spielfeld.add(new ArrayList<XXOKaestchen>());
            
            // Dem Feld der aktuellen Spielfeldzeile werden die drei Kästchen (spaltenweise) hinzugefügt
            for (int spalte = 0; spalte < 3; spalte = spalte + 1)
            {
                spielfeld.get(zeile).add(new XXOKaestchen());
            }
        }        
        
        /*
         * Darstellen des Spielfelds
         */ 
        for (int zeile = 0; zeile < 3; zeile = zeile + 1)
        {         
            for (int spalte = 0; spalte < 3; spalte = spalte + 1)
            {
                XXOKaestchen k;
                k = spielfeld.get(zeile).get(spalte);
                k.PositionSetzen(spalte * 50, zeile * 50);
            }
        }
        
    }
}
