import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.awt.event.*;
import java.util.*;

/**
 * Rahmenklasse des Spiels
 * 
 * @author Albert Wiedemann
 * @version 1.0
 */
public class Spiel extends GrafikWelt
{
    /** Die Schlange.*/
    Schlange schlange;
    /** Der Punktestand */
    int punkte;
    /** Zufallsgeneror für das Spiel */
    Random zzGenerator;
    
    /**
     * Baut die Basiselemente auf.
     */
    public Spiel()
    {
        char richtung;
        int xStart, yStart;
        zzGenerator = new Random();
        switch (zzGenerator.nextInt(4))
        {
            case 0:
                richtung = 'O';
                break;
            case 1:
                richtung = 'N';
                break;
            case 2:
                richtung = 'W';
                break;
            default:
                richtung = 'S';
                break;
        }
        xStart = -5 + zzGenerator.nextInt(10);
        yStart = -4 + zzGenerator.nextInt(8);
        schlange = new Schlange(xStart, yStart, richtung);
        punkte = 0;
    }

    /**
     * Bewegt die Schlange.
     */
    @Override void TaktImpulsAusführen()
    {
        if ((schlange.XPositionGeben() <= XMaxGeben()) && (schlange.XPositionGeben() >= XMinGeben()) &&
            (schlange.YPositionGeben() <= YMaxGeben()) && (schlange.YPositionGeben() >= YMinGeben()) &&
            ! schlange.KopfInRumpf())
        {
            schlange.Bewegen();
            punkte += 1;
            PunkteSetzen(punkte);
        }
        else
        {
            Greenfoot.stop();
            if (schlange.KopfInRumpf())
            {
                EndemeldungSetzen("Game Over - Schlange hat sich selbst gebissen");
            }
            else
            {
                EndemeldungSetzen("Game Over - Schlange über Spielfeldrand");
            }
        }
    }
    
    /**
     * Wertet die Tasteneingaben aus.
     * @param welche Tastencode
     */
    @Override void TasteGedrückt(char welche)
    {
        switch (welche)
        {
          case 'S':
          case 's':
            Greenfoot.start();
            break;
          case 'P':
          case 'p':
            Greenfoot.stop();
            break;
          default:
            //System.out.println("Taste: " + (0 + (int) welche));
        }
    }
    
    /**
     * Wertet die Sondertasten aus.
     * @param welche Tastencode
     */
    @Override void SonderTasteGedrückt(int welche)
    {
        switch (welche)
        {
          case KeyEvent.VK_DOWN:
          case KeyEvent.VK_KP_DOWN:
            schlange.RichtungSetzen('S');
            break;
          case KeyEvent.VK_LEFT:
            schlange.RichtungSetzen('W');
            break;
          case KeyEvent.VK_RIGHT:
            schlange.RichtungSetzen('O');
            break;
          case KeyEvent.VK_UP:
            schlange.RichtungSetzen('N');
            break;
          default:
            //System.out.println("Taste: " + (0 + (int) welche));
        }
    }
}
