
/**
 * Klasse zur Beschreibung einer Checkbox
 *
 * @author Klaus Reinold
 * @version 1.0
 */
public class Checkbox extends Ereignisbehandlung
{
    /** x-Position */
    private int x;
    /** y-Position */
    private int y;
    /** Gibt an, ob der Radiobutton ausgewählt ist. */
    private boolean istAusgewählt;
    /** Das äußere Rechteck */
    private Rechteck rahmen;
    /** Das innere Rechteck, das anzeigt, ob die Checkbox angeklickt ist */
    private Rechteck inneresRechteck;
    /** Breite des Textfelds */
    private int breite;
    /** Das darstellende Textfeld */
    private Text text;

    /**
     * Konstruktor der Checkbox
     */
    public Checkbox()
    {
        x = 20;
        y = 20;
        breite = 300;
        istAusgewählt = false;

        rahmen = new Rechteck();
        GrafikWelt.dieWelt.addObject(rahmen, 0, 0);
        rahmen.GrößeSetzen(12,12);
        rahmen.FarbeSetzen("weiß");

        inneresRechteck = new Rechteck();
        GrafikWelt.dieWelt.addObject(inneresRechteck, 0, 0);
        inneresRechteck.GrößeSetzen(8, 8);
        inneresRechteck.FarbeSetzen("schwarz");
        inneresRechteck.SichtbarkeitSetzen(false);

        text = new Text();
        GrafikWelt.dieWelt.addObject(text, 0, 0);
        text.TextSetzen("Beschreibung der Checkbox");
        
        PositionSetzen(x, y);

    }

    /**
     * Ereignisroutine des Mausklicks
     * @param xKlick x-Position des Mausklicks
     * @param yKlick y-Position des Mausklicks
     * @param anzahl Anzahl der Klicks
     */
    @Override public void MausGeklickt(int xKlick, int yKlick, int anzahl)
    {
        if((xKlick - x)*(xKlick - x) + (yKlick - y)*(yKlick - y) <= 64 )
        {
            if(istAusgewählt)
            {
                istAusgewählt = false;
                inneresRechteck.SichtbarkeitSetzen(false);
            }
            else
            {
                istAusgewählt = true;
                inneresRechteck.SichtbarkeitSetzen(true);
            }
        }
    }

    /**
     * Position der Checkbox setzen
     * @param xNeu neue x-Koordinate
     * @param yNeu neue y-Koordinate
     */
    public void PositionSetzen(int xNeu, int yNeu)
    {
        x = xNeu;
        y = yNeu;
        rahmen.PositionSetzen(x-6, y-6);
        inneresRechteck.PositionSetzen(x-4, y-4);
        text.PositionSetzen(x + 10, y + 6);
    }

    /**
     * Methode zum Setzen des Textes
     * @param tneu neuer Text
     */
    public void TextSetzen(String tNeu)
    {
        text.TextSetzen(tNeu);
    }
    
    /**
     * Verhindert die Ausgabe des Taktgebers
     */
    @Override void TaktImpulsAusführen()
    {
    }
}
