
/**
 * Klasse zur Beschreibung eines Radiobuttons
 *
 * @author Klaus Reinold
 * @version 1.0
 */
public class Radiobutton extends Ereignisbehandlung
{
    /** x-Position */
    private int x;
    /** y-Position */
    private int y;
    /** Gibt an, ob der Radiobutton ausgewählt ist. */
    private boolean istAusgewählt;
    /** Der äußere Kreis */
    private Kreis rahmen;
    /** Der innere Kreis, der anzeigt, ob der Radiobutton angeklickt ist */
    private Kreis innenkreis;
    /** Breite des Textfelds */
    private int breite;
    /** Das darstellende Textfeld */
    private Text text;

    /**
     * Konstruktor des Radiobuttons 
     */
    public Radiobutton()
    {
        x = 20;
        y = 20;
        breite = 300;
        istAusgewählt = false;

        rahmen = new Kreis();
        GrafikWelt.dieWelt.addObject(rahmen, 0, 0);
        rahmen.RadiusSetzen(6);
        rahmen.FarbeSetzen("weiß");

        innenkreis = new Kreis();
        GrafikWelt.dieWelt.addObject(innenkreis, 0, 0);
        innenkreis.RadiusSetzen(4);
        innenkreis.FarbeSetzen("schwarz");
        innenkreis.SichtbarkeitSetzen(false);

        text = new Text();
        GrafikWelt.dieWelt.addObject(text, 0, 0);
        text.TextSetzen("Beschreibung des Radiobuttons");

        PositionSetzen(x, y);
    }

    /**
     * Ereignisroutine des Mausklicks
     * @param xKlick x-Position des Mausklicks
     * @param yKlick y-Position des Mausklicks
     * @param anzahl Anzahl der Klicks
     */
    @Override public void MausGeklickt(int xKlick, int yKlick, int anzahl)
    {

        if((xKlick - x)*(xKlick - x) + (yKlick - y)*(yKlick - y) <= 64 )
        {
            istAusgewählt = true;
            innenkreis.SichtbarkeitSetzen(true);
        }
    }

    /**
     * Position des Textfeldes setzen
     * @param xNeu neue x-Koordinate
     * @param yNeu neue y-Koordinate
     */
    public void PositionSetzen(int xNeu, int yNeu)
    {
        x = xNeu;
        y = yNeu;
        rahmen.PositionSetzen(x, y);
        innenkreis.PositionSetzen(x, y);
        text.PositionSetzen(x + 10, y + 6);
    }

    /**
     * Methode zum Setzen des Textes
     * @param tneu neuer Text
     */
    public void TextSetzen(String tNeu)
    {
        text.TextSetzen(tNeu);
    }

    /**
     * Setzt den Radiobutton auf "nicht ausgewählt"
     */
    public void Deselektieren()
    {
        istAusgewählt = false;
        innenkreis.SichtbarkeitSetzen(false);
    }
    
    /**
     * Verhindert die Ausgabe des Taktgebers
     */
    @Override void TaktImpulsAusführen()
    {
    }
}
