import greenfoot.*;
import java.util.ArrayList;

/**
 * Beschreiben Sie hier die Klasse EKG_Auswertung.
 * 
 * @author Peter Brichzin
 * @version 1.0
 */
public class EKG_Auswertung extends Actor
{
    private ArrayList<Integer> daten;
    private Dateileser dateileser;
    // Zeitabstand zwischen zwei Messwerten in Millisekunden
    private int zeitabstand; 
    private ArrayList<Datenpunkt> maxima;

    /**
     * Konstruktor für Objekte der Klasse EKG_Auswertung
     */
    public EKG_Auswertung()
    {
        daten = new ArrayList<Integer>();
        dateileser = new Dateileser("EKG_Datenreihe1.csv");
        daten = dateileser.ZahlenAuslesen();

        zeitabstand = 2;  
        maxima = new ArrayList<Datenpunkt>();
    }
    
    /**
     * Ausgabe einer Messreihe mit Zeitpunkt in ms und Spannung in mV
     */
    public void DatenreiheAusgeben()
    {
        for(int index = 0; index < daten.size(); index = index + 1)
        {
            System.out.println(index * 2 + " ms:   " + " mV");
        }
    }
   
    /**
     * Ermittelt die maximalen Spannungswerte innerhalb der QRS-Komplexe
     * und deren Zeitpunkte und gibt ein Feld zurück, das diese Werte als Datenpunkte
     * enthält.
     * @return Feld mit den Daten der Maxima
     */
    public ArrayList<Datenpunkt> MaximaBestimmen()
    {
        int maximumSpannung = 0;
        maximumSpannung = 0;
        int zeitpunktMaximum;
        zeitpunktMaximum = 0;
        int anzahlFallendeWerte;
        anzahlFallendeWerte = 0;

        int index = 0;
        while (index < daten.size())
        {
            if(daten.get(index) > 300)  // es werden nur Maxima der QRS-Komplexe gesucht -> Schwellwert muss überschritten sein!
            {
                if(daten.get(index) > maximumSpannung)  
                {
                    maximumSpannung = daten.get(index);
                    zeitpunktMaximum = index * zeitabstand;
                }
                else
                {
                    anzahlFallendeWerte = anzahlFallendeWerte + 1;  //Anzahl der Schritte nach unten werden gezählt
                    if(anzahlFallendeWerte > 3)   // bei mehr als drei Schritten war es kein Ausreißer -> lokales Maximmum gefunden!
                    {
                        maxima.add(new Datenpunkt(zeitpunktMaximum, maximumSpannung)); 
                        index = index + 50;         // 50 ms nach vorne springen
                        zeitpunktMaximum = 0;       // temporäre Variablen zurücksetzen
                        maximumSpannung = 0;        // temporäre Variablen zurücksetzen
                    }
                }
            }
            index = index + 1;
        }
        return maxima;
    }          
}
